/* app_settings.c generated by valac 0.40.4, the Vala compiler
 * generated from app_settings.vala, do not modify */

/*
 * This file is part of GNOME LaTeX.
 *
 * Copyright © 2010-2011 Sébastien Wilmet
 *
 * GNOME LaTeX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME LaTeX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME LaTeX.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <tepl/tepl.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksource.h>


#define TYPE_APP_SETTINGS (app_settings_get_type ())
#define APP_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_SETTINGS, AppSettings))
#define APP_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_SETTINGS, AppSettingsClass))
#define IS_APP_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_SETTINGS))
#define IS_APP_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_SETTINGS))
#define APP_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_SETTINGS, AppSettingsClass))

typedef struct _AppSettings AppSettings;
typedef struct _AppSettingsClass AppSettingsClass;
typedef struct _AppSettingsPrivate AppSettingsPrivate;
enum  {
	APP_SETTINGS_0_PROPERTY,
	APP_SETTINGS_SYSTEM_FONT_PROPERTY,
	APP_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* app_settings_properties[APP_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DOCUMENT_VIEW (document_view_get_type ())
#define DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_VIEW, DocumentView))
#define DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_VIEW, DocumentViewClass))
#define IS_DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_VIEW))
#define IS_DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_VIEW))
#define DOCUMENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_VIEW, DocumentViewClass))

typedef struct _DocumentView DocumentView;
typedef struct _DocumentViewClass DocumentViewClass;

#define TYPE_GLATEX_APP (glatex_app_get_type ())
#define GLATEX_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GLATEX_APP, GlatexApp))
#define GLATEX_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GLATEX_APP, GlatexAppClass))
#define IS_GLATEX_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GLATEX_APP))
#define IS_GLATEX_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GLATEX_APP))
#define GLATEX_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GLATEX_APP, GlatexAppClass))

typedef struct _GlatexApp GlatexApp;
typedef struct _GlatexAppClass GlatexAppClass;

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
typedef struct _DocumentPrivate DocumentPrivate;

#define TYPE_DOCUMENT_TAB (document_tab_get_type ())
#define DOCUMENT_TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_TAB, DocumentTab))
#define DOCUMENT_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_TAB, DocumentTabClass))
#define IS_DOCUMENT_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_TAB))
#define IS_DOCUMENT_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_TAB))
#define DOCUMENT_TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_TAB, DocumentTabClass))

typedef struct _DocumentTab DocumentTab;
typedef struct _DocumentTabClass DocumentTabClass;

struct _AppSettings {
	GSettings parent_instance;
	AppSettingsPrivate * priv;
};

struct _AppSettingsClass {
	GSettingsClass parent_class;
};

struct _AppSettingsPrivate {
	GSettings* editor;
	gchar* _system_font;
};

struct _Document {
	TeplBuffer parent_instance;
	DocumentPrivate * priv;
	DocumentTab* tab;
};

struct _DocumentClass {
	TeplBufferClass parent_class;
};


static gpointer app_settings_parent_class = NULL;
static AppSettings* app_settings_instance;
static AppSettings* app_settings_instance = NULL;

GType app_settings_get_type (void) G_GNUC_CONST;
#define APP_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_APP_SETTINGS, AppSettingsPrivate))
static AppSettings* app_settings_new (void);
static AppSettings* app_settings_construct (GType object_type);
static void app_settings_initialize (AppSettings* self);
AppSettings* app_settings_get_default (void);
static void app_settings_set_system_font (AppSettings* self,
                                   const gchar* value);
static void __lambda4_ (AppSettings* self,
                 GSettings* setting,
                 const gchar* key);
static void app_settings_set_font (AppSettings* self,
                            const gchar* font);
const gchar* app_settings_get_system_font (AppSettings* self);
static void ___lambda4__g_settings_changed (GSettings* _sender,
                                     const gchar* key,
                                     gpointer self);
static void __lambda122_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
static void ___lambda122__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda123_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
static void ___lambda123__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda124_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
GType document_view_get_type (void) G_GNUC_CONST;
GType glatex_app_get_type (void) G_GNUC_CONST;
GlatexApp* glatex_app_get_instance (void);
GeeList* glatex_app_get_views (GlatexApp* self);
static void ___lambda124__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda125_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
static void ___lambda125__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda126_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
static void ___lambda126__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda127_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
static void ___lambda127__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda128_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
GType document_get_type (void) G_GNUC_CONST;
GeeList* glatex_app_get_documents (GlatexApp* self);
static void ___lambda128__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda129_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
GType document_tab_get_type (void) G_GNUC_CONST;
void document_tab_set_auto_save (DocumentTab* self,
                                 gboolean value);
static void ___lambda129__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
static void __lambda130_ (AppSettings* self,
                   GSettings* setting,
                   const gchar* key);
void document_tab_set_auto_save_interval (DocumentTab* self,
                                          guint value);
static void ___lambda130__g_settings_changed (GSettings* _sender,
                                       const gchar* key,
                                       gpointer self);
void document_view_set_font_from_string (DocumentView* self,
                                         const gchar* font);
static void app_settings_finalize (GObject * obj);
static void _vala_app_settings_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_app_settings_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);


static AppSettings*
app_settings_construct (GType object_type)
{
	AppSettings * self = NULL;
	self = (AppSettings*) g_object_new (object_type, "schema-id", "org.gnome.gnome-latex", NULL);
	app_settings_initialize (self);
	return self;
}


static AppSettings*
app_settings_new (void)
{
	return app_settings_construct (TYPE_APP_SETTINGS);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


AppSettings*
app_settings_get_default (void)
{
	AppSettings* result = NULL;
	AppSettings* _tmp0_;
	AppSettings* _tmp2_;
	AppSettings* _tmp3_;
	_tmp0_ = app_settings_instance;
	if (_tmp0_ == NULL) {
		AppSettings* _tmp1_;
		_tmp1_ = app_settings_new ();
		_g_object_unref0 (app_settings_instance);
		app_settings_instance = _tmp1_;
	}
	_tmp2_ = app_settings_instance;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}


static void
__lambda4_ (AppSettings* self,
            GSettings* setting,
            const gchar* key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GSettings* _tmp2_;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = g_settings_get_string (setting, key);
	_tmp1_ = _tmp0_;
	app_settings_set_system_font (self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->editor;
	if (g_settings_get_boolean (_tmp2_, "use-default-font")) {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->_system_font;
		app_settings_set_font (self, _tmp3_);
	}
}


static void
___lambda4__g_settings_changed (GSettings* _sender,
                                const gchar* key,
                                gpointer self)
{
	__lambda4_ ((AppSettings*) self, _sender, key);
}


static void
__lambda122_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gchar* font = NULL;
	gchar* _tmp6_;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	_tmp1_ = val;
	if (_tmp1_) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = self->priv->_system_font;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp3_;
	} else {
		GSettings* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = self->priv->editor;
		_tmp5_ = g_settings_get_string (_tmp4_, "editor-font");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = g_strdup (_tmp0_);
	font = _tmp6_;
	app_settings_set_font (self, font);
	_g_free0 (font);
	_g_free0 (_tmp0_);
}


static void
___lambda122__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda122_ ((AppSettings*) self, _sender, key);
}


static void
__lambda123_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->editor;
	if (g_settings_get_boolean (_tmp0_, "use-default-font")) {
		return;
	}
	_tmp1_ = g_settings_get_string (setting, key);
	_tmp2_ = _tmp1_;
	app_settings_set_font (self, _tmp2_);
	_g_free0 (_tmp2_);
}


static void
___lambda123__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda123_ ((AppSettings*) self, _sender, key);
}


static void
__lambda124_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	guint val = 0U;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	g_settings_get (setting, key, "u", &val);
	{
		GeeList* _view_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_views (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_view_list = _tmp3_;
		_tmp4_ = _view_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_view_size = _tmp6_;
		_view_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			DocumentView* view = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			DocumentView* _tmp13_;
			guint _tmp14_;
			_tmp7_ = _view_index;
			_view_index = _tmp7_ + 1;
			_tmp8_ = _view_index;
			_tmp9_ = _view_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _view_list;
			_tmp11_ = _view_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			view = (DocumentView*) _tmp12_;
			_tmp13_ = view;
			_tmp14_ = val;
			gtk_source_view_set_tab_width ((GtkSourceView*) _tmp13_, _tmp14_);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
}


static void
___lambda124__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda124_ ((AppSettings*) self, _sender, key);
}


static void
__lambda125_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	{
		GeeList* _view_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_views (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_view_list = _tmp3_;
		_tmp4_ = _view_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_view_size = _tmp6_;
		_view_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			DocumentView* view = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			DocumentView* _tmp13_;
			gboolean _tmp14_;
			_tmp7_ = _view_index;
			_view_index = _tmp7_ + 1;
			_tmp8_ = _view_index;
			_tmp9_ = _view_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _view_list;
			_tmp11_ = _view_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			view = (DocumentView*) _tmp12_;
			_tmp13_ = view;
			_tmp14_ = val;
			gtk_source_view_set_insert_spaces_instead_of_tabs ((GtkSourceView*) _tmp13_, _tmp14_);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
}


static void
___lambda125__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda125_ ((AppSettings*) self, _sender, key);
}


static void
__lambda126_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	{
		GeeList* _view_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_views (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_view_list = _tmp3_;
		_tmp4_ = _view_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_view_size = _tmp6_;
		_view_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			DocumentView* view = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			DocumentView* _tmp13_;
			gboolean _tmp14_;
			_tmp7_ = _view_index;
			_view_index = _tmp7_ + 1;
			_tmp8_ = _view_index;
			_tmp9_ = _view_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _view_list;
			_tmp11_ = _view_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			view = (DocumentView*) _tmp12_;
			_tmp13_ = view;
			_tmp14_ = val;
			gtk_source_view_set_show_line_numbers ((GtkSourceView*) _tmp13_, _tmp14_);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
}


static void
___lambda126__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda126_ ((AppSettings*) self, _sender, key);
}


static void
__lambda127_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	{
		GeeList* _view_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_views (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_view_list = _tmp3_;
		_tmp4_ = _view_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_view_size = _tmp6_;
		_view_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			DocumentView* view = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			DocumentView* _tmp13_;
			gboolean _tmp14_;
			_tmp7_ = _view_index;
			_view_index = _tmp7_ + 1;
			_tmp8_ = _view_index;
			_tmp9_ = _view_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _view_list;
			_tmp11_ = _view_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			view = (DocumentView*) _tmp12_;
			_tmp13_ = view;
			_tmp14_ = val;
			gtk_source_view_set_highlight_current_line ((GtkSourceView*) _tmp13_, _tmp14_);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
}


static void
___lambda127__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda127_ ((AppSettings*) self, _sender, key);
}


static void
__lambda128_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	{
		GeeList* _doc_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _doc_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _doc_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_documents (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_doc_list = _tmp3_;
		_tmp4_ = _doc_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_doc_size = _tmp6_;
		_doc_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			Document* doc = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			Document* _tmp13_;
			gboolean _tmp14_;
			_tmp7_ = _doc_index;
			_doc_index = _tmp7_ + 1;
			_tmp8_ = _doc_index;
			_tmp9_ = _doc_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _doc_list;
			_tmp11_ = _doc_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			doc = (Document*) _tmp12_;
			_tmp13_ = doc;
			_tmp14_ = val;
			gtk_source_buffer_set_highlight_matching_brackets ((GtkSourceBuffer*) _tmp13_, _tmp14_);
			_g_object_unref0 (doc);
		}
		_g_object_unref0 (_doc_list);
	}
}


static void
___lambda128__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda128_ ((AppSettings*) self, _sender, key);
}


static void
__lambda129_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	gboolean val = FALSE;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	val = g_settings_get_boolean (setting, key);
	{
		GeeList* _doc_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _doc_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _doc_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_documents (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_doc_list = _tmp3_;
		_tmp4_ = _doc_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_doc_size = _tmp6_;
		_doc_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			Document* doc = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			Document* _tmp13_;
			DocumentTab* _tmp14_;
			gboolean _tmp15_;
			_tmp7_ = _doc_index;
			_doc_index = _tmp7_ + 1;
			_tmp8_ = _doc_index;
			_tmp9_ = _doc_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _doc_list;
			_tmp11_ = _doc_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			doc = (Document*) _tmp12_;
			_tmp13_ = doc;
			_tmp14_ = _tmp13_->tab;
			_tmp15_ = val;
			document_tab_set_auto_save (_tmp14_, _tmp15_);
			_g_object_unref0 (doc);
		}
		_g_object_unref0 (_doc_list);
	}
}


static void
___lambda129__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda129_ ((AppSettings*) self, _sender, key);
}


static void
__lambda130_ (AppSettings* self,
              GSettings* setting,
              const gchar* key)
{
	guint val = 0U;
	g_return_if_fail (setting != NULL);
	g_return_if_fail (key != NULL);
	g_settings_get (setting, key, "u", &val);
	{
		GeeList* _doc_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _doc_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _doc_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_documents (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_doc_list = _tmp3_;
		_tmp4_ = _doc_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_doc_size = _tmp6_;
		_doc_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			Document* doc = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			Document* _tmp13_;
			DocumentTab* _tmp14_;
			guint _tmp15_;
			_tmp7_ = _doc_index;
			_doc_index = _tmp7_ + 1;
			_tmp8_ = _doc_index;
			_tmp9_ = _doc_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _doc_list;
			_tmp11_ = _doc_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			doc = (Document*) _tmp12_;
			_tmp13_ = doc;
			_tmp14_ = _tmp13_->tab;
			_tmp15_ = val;
			document_tab_set_auto_save_interval (_tmp14_, _tmp15_);
			_g_object_unref0 (doc);
		}
		_g_object_unref0 (_doc_list);
	}
}


static void
___lambda130__g_settings_changed (GSettings* _sender,
                                  const gchar* key,
                                  gpointer self)
{
	__lambda130_ ((AppSettings*) self, _sender, key);
}


static void
app_settings_initialize (AppSettings* self)
{
	GSettings* prefs = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* desktop_interface = NULL;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GSettings* _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_settings_get_child ((GSettings*) self, "preferences");
	prefs = _tmp0_;
	_tmp1_ = g_settings_get_child (prefs, "editor");
	_g_object_unref0 (self->priv->editor);
	self->priv->editor = _tmp1_;
	_tmp2_ = g_settings_new ("org.gnome.desktop.interface");
	desktop_interface = _tmp2_;
	_tmp3_ = g_settings_get_string (desktop_interface, "monospace-font-name");
	_tmp4_ = _tmp3_;
	app_settings_set_system_font (self, _tmp4_);
	_g_free0 (_tmp4_);
	g_signal_connect_object (desktop_interface, "changed::monospace-font-name", (GCallback) ___lambda4__g_settings_changed, self, 0);
	_tmp5_ = self->priv->editor;
	g_signal_connect_object (_tmp5_, "changed::use-default-font", (GCallback) ___lambda122__g_settings_changed, self, 0);
	_tmp6_ = self->priv->editor;
	g_signal_connect_object (_tmp6_, "changed::editor-font", (GCallback) ___lambda123__g_settings_changed, self, 0);
	_tmp7_ = self->priv->editor;
	g_signal_connect_object (_tmp7_, "changed::tabs-size", (GCallback) ___lambda124__g_settings_changed, self, 0);
	_tmp8_ = self->priv->editor;
	g_signal_connect_object (_tmp8_, "changed::insert-spaces", (GCallback) ___lambda125__g_settings_changed, self, 0);
	_tmp9_ = self->priv->editor;
	g_signal_connect_object (_tmp9_, "changed::display-line-numbers", (GCallback) ___lambda126__g_settings_changed, self, 0);
	_tmp10_ = self->priv->editor;
	g_signal_connect_object (_tmp10_, "changed::highlight-current-line", (GCallback) ___lambda127__g_settings_changed, self, 0);
	_tmp11_ = self->priv->editor;
	g_signal_connect_object (_tmp11_, "changed::bracket-matching", (GCallback) ___lambda128__g_settings_changed, self, 0);
	_tmp12_ = self->priv->editor;
	g_signal_connect_object (_tmp12_, "changed::auto-save", (GCallback) ___lambda129__g_settings_changed, self, 0);
	_tmp13_ = self->priv->editor;
	g_signal_connect_object (_tmp13_, "changed::auto-save-interval", (GCallback) ___lambda130__g_settings_changed, self, 0);
	_g_object_unref0 (desktop_interface);
	_g_object_unref0 (prefs);
}


static void
app_settings_set_font (AppSettings* self,
                       const gchar* font)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (font != NULL);
	{
		GeeList* _view_list = NULL;
		GlatexApp* _tmp0_;
		GlatexApp* _tmp1_;
		GeeList* _tmp2_;
		GeeList* _tmp3_;
		gint _view_size = 0;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _view_index = 0;
		_tmp0_ = glatex_app_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = glatex_app_get_views (_tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_view_list = _tmp3_;
		_tmp4_ = _view_list;
		_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
		_tmp6_ = _tmp5_;
		_view_size = _tmp6_;
		_view_index = -1;
		while (TRUE) {
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			DocumentView* view = NULL;
			GeeList* _tmp10_;
			gint _tmp11_;
			gpointer _tmp12_;
			DocumentView* _tmp13_;
			_tmp7_ = _view_index;
			_view_index = _tmp7_ + 1;
			_tmp8_ = _view_index;
			_tmp9_ = _view_size;
			if (!(_tmp8_ < _tmp9_)) {
				break;
			}
			_tmp10_ = _view_list;
			_tmp11_ = _view_index;
			_tmp12_ = gee_list_get (_tmp10_, _tmp11_);
			view = (DocumentView*) _tmp12_;
			_tmp13_ = view;
			document_view_set_font_from_string (_tmp13_, font);
			_g_object_unref0 (view);
		}
		_g_object_unref0 (_view_list);
	}
}


const gchar*
app_settings_get_system_font (AppSettings* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_system_font;
	result = _tmp0_;
	return result;
}


static void
app_settings_set_system_font (AppSettings* self,
                              const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, app_settings_get_system_font (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_system_font);
		self->priv->_system_font = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, app_settings_properties[APP_SETTINGS_SYSTEM_FONT_PROPERTY]);
	}
}


static void
app_settings_class_init (AppSettingsClass * klass)
{
	app_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AppSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_app_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_app_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = app_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_SETTINGS_SYSTEM_FONT_PROPERTY, app_settings_properties[APP_SETTINGS_SYSTEM_FONT_PROPERTY] = g_param_spec_string ("system-font", "system-font", "system-font", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
app_settings_instance_init (AppSettings * self)
{
	self->priv = APP_SETTINGS_GET_PRIVATE (self);
}


static void
app_settings_finalize (GObject * obj)
{
	AppSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_SETTINGS, AppSettings);
	_g_object_unref0 (self->priv->editor);
	_g_free0 (self->priv->_system_font);
	G_OBJECT_CLASS (app_settings_parent_class)->finalize (obj);
}


GType
app_settings_get_type (void)
{
	static volatile gsize app_settings_type_id__volatile = 0;
	if (g_once_init_enter (&app_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppSettings), 0, (GInstanceInitFunc) app_settings_instance_init, NULL };
		GType app_settings_type_id;
		app_settings_type_id = g_type_register_static (g_settings_get_type (), "AppSettings", &g_define_type_info, 0);
		g_once_init_leave (&app_settings_type_id__volatile, app_settings_type_id);
	}
	return app_settings_type_id__volatile;
}


static void
_vala_app_settings_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	AppSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_SETTINGS, AppSettings);
	switch (property_id) {
		case APP_SETTINGS_SYSTEM_FONT_PROPERTY:
		g_value_set_string (value, app_settings_get_system_font (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_app_settings_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AppSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_SETTINGS, AppSettings);
	switch (property_id) {
		case APP_SETTINGS_SYSTEM_FONT_PROPERTY:
		app_settings_set_system_font (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



