/* document_tab.c generated by valac 0.40.4, the Vala compiler
 * generated from document_tab.vala, do not modify */

/*
 * This file is part of GNOME LaTeX.
 *
 * Copyright © 2010, 2011, 2017 Sébastien Wilmet
 *
 * GNOME LaTeX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME LaTeX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME LaTeX.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <tepl/tepl.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_DOCUMENT_TAB (document_tab_get_type ())
#define DOCUMENT_TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_TAB, DocumentTab))
#define DOCUMENT_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_TAB, DocumentTabClass))
#define IS_DOCUMENT_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_TAB))
#define IS_DOCUMENT_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_TAB))
#define DOCUMENT_TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_TAB, DocumentTabClass))

typedef struct _DocumentTab DocumentTab;
typedef struct _DocumentTabClass DocumentTabClass;
typedef struct _DocumentTabPrivate DocumentTabPrivate;
enum  {
	DOCUMENT_TAB_0_PROPERTY,
	DOCUMENT_TAB_DOCUMENT_VIEW_PROPERTY,
	DOCUMENT_TAB_DOCUMENT_PROPERTY,
	DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY,
	DOCUMENT_TAB_AUTO_SAVE_PROPERTY,
	DOCUMENT_TAB_NUM_PROPERTIES
};
static GParamSpec* document_tab_properties[DOCUMENT_TAB_NUM_PROPERTIES];

#define TYPE_DOCUMENT_VIEW (document_view_get_type ())
#define DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_VIEW, DocumentView))
#define DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_VIEW, DocumentViewClass))
#define IS_DOCUMENT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_VIEW))
#define IS_DOCUMENT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_VIEW))
#define DOCUMENT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_VIEW, DocumentViewClass))

typedef struct _DocumentView DocumentView;
typedef struct _DocumentViewClass DocumentViewClass;

#define TYPE_DOCUMENT (document_get_type ())
#define DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT, Document))
#define DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT, DocumentClass))
#define IS_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT))
#define IS_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT))
#define DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT, DocumentClass))

typedef struct _Document Document;
typedef struct _DocumentClass DocumentClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _DocumentPrivate DocumentPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block14Data Block14Data;

struct _DocumentTab {
	TeplTab parent_instance;
	DocumentTabPrivate * priv;
};

struct _DocumentTabClass {
	TeplTabClass parent_class;
};

struct _DocumentTabPrivate {
	gboolean ask_if_externally_modified;
	guint auto_save_timeout;
	guint _auto_save_interval;
	gboolean _auto_save;
};

struct _Document {
	TeplBuffer parent_instance;
	DocumentPrivate * priv;
	DocumentTab* tab;
};

struct _DocumentClass {
	TeplBufferClass parent_class;
};

struct _Block14Data {
	int _ref_count_;
	DocumentTab* self;
	TeplInfoBar* infobar;
};


static gpointer document_tab_parent_class = NULL;

GType document_tab_get_type (void) G_GNUC_CONST;
#define DOCUMENT_TAB_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DOCUMENT_TAB, DocumentTabPrivate))
DocumentTab* document_tab_new (void);
DocumentTab* document_tab_construct (GType object_type);
GType document_view_get_type (void) G_GNUC_CONST;
Document* document_new (void);
Document* document_construct (GType object_type);
GType document_get_type (void) G_GNUC_CONST;
DocumentView* document_view_new (Document* doc);
DocumentView* document_view_construct (GType object_type,
                                       Document* doc);
static void document_tab_initialize (DocumentTab* self);
DocumentTab* document_tab_new_from_location (GFile* location);
DocumentTab* document_tab_construct_from_location (GType object_type,
                                                   GFile* location);
Document* document_tab_get_document (DocumentTab* self);
void document_load (Document* self,
                    GFile* location);
DocumentTab* document_tab_new_with_view (DocumentView* document_view);
DocumentTab* document_tab_construct_with_view (GType object_type,
                                               DocumentView* document_view);
DocumentView* document_tab_get_document_view (DocumentTab* self);
static gboolean document_tab_view_focused_in (DocumentTab* self);
static gboolean _document_tab_view_focused_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                  GdkEventFocus* event,
                                                                  gpointer self);
TeplView* tepl_tab_get_view (TeplTab* self);
void document_tab_set_auto_save (DocumentTab* self,
                                 gboolean value);
void document_tab_set_auto_save_interval (DocumentTab* self,
                                          guint value);
static gboolean document_tab_install_auto_save_timeout_if_needed (DocumentTab* self);
static void __lambda21_ (DocumentTab* self);
static void ___lambda21__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
gchar* document_tab_get_menu_tip (DocumentTab* self);
gchar* document_get_uri_for_display (Document* self);
gboolean document_is_externally_modified (Document* self);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
GFile* document_get_location (Document* self);
static void ___lambda20_ (Block14Data* _data14_,
                   gint response_id);
static void ____lambda20__gtk_info_bar_response (GtkInfoBar* _sender,
                                          gint response_id,
                                          gpointer self);
static void document_tab_install_auto_save_timeout (DocumentTab* self);
gboolean document_tab_get_auto_save (DocumentTab* self);
guint document_tab_get_auto_save_interval (DocumentTab* self);
static gboolean document_tab_on_auto_save (DocumentTab* self);
static gboolean _document_tab_on_auto_save_gsource_func (gpointer self);
gboolean document_get_readonly (Document* self);
static void document_tab_remove_auto_save_timeout (DocumentTab* self);
void document_save (Document* self,
                    gboolean check_file_changed_on_disk,
                    gboolean force);
static void document_tab_finalize (GObject * obj);
static void _vala_document_tab_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_document_tab_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);


DocumentTab*
document_tab_construct (GType object_type)
{
	DocumentTab * self = NULL;
	DocumentView* document_view = NULL;
	Document* _tmp0_;
	Document* _tmp1_;
	DocumentView* _tmp2_;
	DocumentView* _tmp3_;
	_tmp0_ = document_new ();
	_tmp1_ = _tmp0_;
	_tmp2_ = document_view_new (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	document_view = _tmp3_;
	self = (DocumentTab*) g_object_new (object_type, "view", document_view, NULL);
	document_tab_initialize (self);
	_g_object_unref0 (document_view);
	return self;
}


DocumentTab*
document_tab_new (void)
{
	return document_tab_construct (TYPE_DOCUMENT_TAB);
}


DocumentTab*
document_tab_construct_from_location (GType object_type,
                                      GFile* location)
{
	DocumentTab * self = NULL;
	Document* _tmp0_;
	Document* _tmp1_;
	g_return_val_if_fail (location != NULL, NULL);
	self = (DocumentTab*) document_tab_construct (object_type);
	_tmp0_ = document_tab_get_document (self);
	_tmp1_ = _tmp0_;
	document_load (_tmp1_, location);
	return self;
}


DocumentTab*
document_tab_new_from_location (GFile* location)
{
	return document_tab_construct_from_location (TYPE_DOCUMENT_TAB, location);
}


DocumentTab*
document_tab_construct_with_view (GType object_type,
                                  DocumentView* document_view)
{
	DocumentTab * self = NULL;
	g_return_val_if_fail (document_view != NULL, NULL);
	self = (DocumentTab*) g_object_new (object_type, "view", document_view, NULL);
	document_tab_initialize (self);
	return self;
}


DocumentTab*
document_tab_new_with_view (DocumentView* document_view)
{
	return document_tab_construct_with_view (TYPE_DOCUMENT_TAB, document_view);
}


static gboolean
_document_tab_view_focused_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                         GdkEventFocus* event,
                                                         gpointer self)
{
	gboolean result;
	result = document_tab_view_focused_in ((DocumentTab*) self);
	return result;
}


static void
__lambda21_ (DocumentTab* self)
{
	guint _tmp0_;
	_tmp0_ = self->priv->auto_save_timeout;
	if (_tmp0_ <= ((guint) 0)) {
		document_tab_install_auto_save_timeout_if_needed (self);
	}
}


static void
___lambda21__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda21_ ((DocumentTab*) self);
}


static void
document_tab_initialize (DocumentTab* self)
{
	Document* _tmp0_;
	Document* _tmp1_;
	DocumentView* _tmp2_;
	DocumentView* _tmp3_;
	TeplView* _tmp4_;
	TeplView* _tmp5_;
	GSettings* settings = NULL;
	GSettings* _tmp6_;
	guint tmp = 0U;
	Document* _tmp7_;
	Document* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = document_tab_get_document (self);
	_tmp1_ = _tmp0_;
	_tmp1_->tab = self;
	_tmp2_ = document_tab_get_document_view (self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((GtkWidget*) _tmp3_, "focus-in-event", (GCallback) _document_tab_view_focused_in_gtk_widget_focus_in_event, self, 0);
	_tmp4_ = tepl_tab_get_view ((TeplTab*) self);
	_tmp5_ = _tmp4_;
	gtk_widget_show_all ((GtkWidget*) _tmp5_);
	_tmp6_ = g_settings_new ("org.gnome.gnome-latex.preferences.editor");
	settings = _tmp6_;
	document_tab_set_auto_save (self, g_settings_get_boolean (settings, "auto-save"));
	g_settings_get (settings, "auto-save-interval", "u", &tmp);
	document_tab_set_auto_save_interval (self, tmp);
	document_tab_install_auto_save_timeout_if_needed (self);
	_tmp7_ = document_tab_get_document (self);
	_tmp8_ = _tmp7_;
	g_signal_connect_object ((GObject*) _tmp8_, "notify::location", (GCallback) ___lambda21__g_object_notify, self, 0);
	_g_object_unref0 (settings);
}


gchar*
document_tab_get_menu_tip (DocumentTab* self)
{
	gchar* result = NULL;
	Document* _tmp0_;
	Document* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = document_tab_get_document (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = document_get_uri_for_display (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf (_ ("Activate '%s'"), _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}


static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}


static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		DocumentTab* self;
		self = _data14_->self;
		_g_object_unref0 (_data14_->infobar);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}


static void
___lambda20_ (Block14Data* _data14_,
              gint response_id)
{
	DocumentTab* self;
	TeplInfoBar* _tmp6_;
	DocumentView* _tmp7_;
	DocumentView* _tmp8_;
	self = _data14_->self;
	if (response_id == ((gint) GTK_RESPONSE_OK)) {
		Document* _tmp0_;
		Document* _tmp1_;
		Document* _tmp2_;
		Document* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		_tmp0_ = document_tab_get_document (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = document_tab_get_document (self);
		_tmp3_ = _tmp2_;
		_tmp4_ = document_get_location (_tmp3_);
		_tmp5_ = _tmp4_;
		document_load (_tmp1_, _tmp5_);
		self->priv->ask_if_externally_modified = FALSE;
	}
	_tmp6_ = _data14_->infobar;
	gtk_widget_destroy ((GtkWidget*) _tmp6_);
	_tmp7_ = document_tab_get_document_view (self);
	_tmp8_ = _tmp7_;
	gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
}


static void
____lambda20__gtk_info_bar_response (GtkInfoBar* _sender,
                                     gint response_id,
                                     gpointer self)
{
	___lambda20_ (self, response_id);
}


static gboolean
document_tab_view_focused_in (DocumentTab* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	TeplBuffer* _tmp1_;
	TeplFile* _tmp2_;
	Document* _tmp3_;
	Document* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->ask_if_externally_modified;
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = tepl_tab_get_buffer ((TeplTab*) self);
	_tmp2_ = tepl_buffer_get_file (_tmp1_);
	if (!tepl_file_is_local (_tmp2_)) {
		result = FALSE;
		return result;
	}
	_tmp3_ = document_tab_get_document (self);
	_tmp4_ = _tmp3_;
	if (document_is_externally_modified (_tmp4_)) {
		Block14Data* _data14_;
		gchar* primary_msg = NULL;
		Document* _tmp5_;
		Document* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* secondary_msg = NULL;
		Document* _tmp13_;
		Document* _tmp14_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		TeplInfoBar* _tmp19_;
		TeplInfoBar* _tmp20_;
		TeplInfoBar* _tmp21_;
		TeplInfoBar* _tmp22_;
		TeplInfoBar* _tmp23_;
		TeplInfoBar* _tmp24_;
		_data14_ = g_slice_new0 (Block14Data);
		_data14_->_ref_count_ = 1;
		_data14_->self = g_object_ref (self);
		self->priv->ask_if_externally_modified = TRUE;
		_tmp5_ = document_tab_get_document (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = document_get_location (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_file_get_parse_name (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup_printf (_ ("The file %s changed on disk."), _tmp10_);
		_tmp12_ = _tmp11_;
		_g_free0 (_tmp10_);
		primary_msg = _tmp12_;
		_tmp13_ = document_tab_get_document (self);
		_tmp14_ = _tmp13_;
		if (gtk_text_buffer_get_modified ((GtkTextBuffer*) _tmp14_)) {
			gchar* _tmp15_;
			_tmp15_ = g_strdup (_ ("Do you want to drop your changes and reload the file?"));
			_g_free0 (secondary_msg);
			secondary_msg = _tmp15_;
		} else {
			gchar* _tmp16_;
			_tmp16_ = g_strdup (_ ("Do you want to reload the file?"));
			_g_free0 (secondary_msg);
			secondary_msg = _tmp16_;
		}
		_tmp17_ = primary_msg;
		_tmp18_ = secondary_msg;
		_tmp19_ = tepl_info_bar_new_simple (GTK_MESSAGE_WARNING, _tmp17_, _tmp18_);
		g_object_ref_sink (_tmp19_);
		_data14_->infobar = _tmp19_;
		_tmp20_ = _data14_->infobar;
		gtk_info_bar_add_button ((GtkInfoBar*) _tmp20_, _ ("_Reload"), (gint) GTK_RESPONSE_OK);
		_tmp21_ = _data14_->infobar;
		gtk_info_bar_add_button ((GtkInfoBar*) _tmp21_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
		_tmp22_ = _data14_->infobar;
		tepl_tab_add_info_bar ((TeplTab*) self, (GtkInfoBar*) _tmp22_);
		_tmp23_ = _data14_->infobar;
		gtk_widget_show ((GtkWidget*) _tmp23_);
		_tmp24_ = _data14_->infobar;
		g_signal_connect_data ((GtkInfoBar*) _tmp24_, "response", (GCallback) ____lambda20__gtk_info_bar_response, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
		_g_free0 (secondary_msg);
		_g_free0 (primary_msg);
		block14_data_unref (_data14_);
		_data14_ = NULL;
	}
	result = FALSE;
	return result;
}


static gboolean
_document_tab_on_auto_save_gsource_func (gpointer self)
{
	gboolean result;
	result = document_tab_on_auto_save ((DocumentTab*) self);
	return result;
}


static void
document_tab_install_auto_save_timeout (DocumentTab* self)
{
	guint _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->auto_save_timeout;
	g_return_if_fail (_tmp0_ <= ((guint) 0));
	_tmp1_ = document_tab_get_auto_save (self);
	_tmp2_ = _tmp1_;
	g_return_if_fail (_tmp2_);
	_tmp3_ = document_tab_get_auto_save_interval (self);
	_tmp4_ = _tmp3_;
	g_return_if_fail (_tmp4_ > ((guint) 0));
	_tmp5_ = document_tab_get_auto_save_interval (self);
	_tmp6_ = _tmp5_;
	self->priv->auto_save_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _tmp6_ * 60, _document_tab_on_auto_save_gsource_func, g_object_ref (self), g_object_unref);
}


static gboolean
document_tab_install_auto_save_timeout_if_needed (DocumentTab* self)
{
	gboolean result = FALSE;
	guint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->auto_save_timeout;
	g_return_val_if_fail (_tmp0_ <= ((guint) 0), FALSE);
	_tmp3_ = document_tab_get_auto_save (self);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		Document* _tmp5_;
		Document* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		_tmp5_ = document_tab_get_document (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = document_get_location (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = _tmp8_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		Document* _tmp9_;
		Document* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp9_ = document_tab_get_document (self);
		_tmp10_ = _tmp9_;
		_tmp11_ = document_get_readonly (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp1_ = !_tmp12_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		document_tab_install_auto_save_timeout (self);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void
document_tab_remove_auto_save_timeout (DocumentTab* self)
{
	guint _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->auto_save_timeout;
	g_return_if_fail (_tmp0_ > ((guint) 0));
	_tmp1_ = self->priv->auto_save_timeout;
	g_source_remove (_tmp1_);
	self->priv->auto_save_timeout = (guint) 0;
}


static gboolean
document_tab_on_auto_save (DocumentTab* self)
{
	gboolean result = FALSE;
	Document* _tmp0_;
	Document* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	Document* _tmp4_;
	Document* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	guint _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	Document* _tmp13_;
	Document* _tmp14_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = document_tab_get_document (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = document_get_location (_tmp1_);
	_tmp3_ = _tmp2_;
	g_return_val_if_fail (_tmp3_ != NULL, FALSE);
	_tmp4_ = document_tab_get_document (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = document_get_readonly (_tmp5_);
	_tmp7_ = _tmp6_;
	g_return_val_if_fail (!_tmp7_, FALSE);
	_tmp8_ = self->priv->auto_save_timeout;
	g_return_val_if_fail (_tmp8_ > ((guint) 0), FALSE);
	_tmp9_ = document_tab_get_auto_save (self);
	_tmp10_ = _tmp9_;
	g_return_val_if_fail (_tmp10_, FALSE);
	_tmp11_ = document_tab_get_auto_save_interval (self);
	_tmp12_ = _tmp11_;
	g_return_val_if_fail (_tmp12_ > ((guint) 0), FALSE);
	_tmp13_ = document_tab_get_document (self);
	_tmp14_ = _tmp13_;
	if (gtk_text_buffer_get_modified ((GtkTextBuffer*) _tmp14_)) {
		Document* _tmp15_;
		Document* _tmp16_;
		_tmp15_ = document_tab_get_document (self);
		_tmp16_ = _tmp15_;
		document_save (_tmp16_, TRUE, FALSE);
	}
	result = TRUE;
	return result;
}


DocumentView*
document_tab_get_document_view (DocumentTab* self)
{
	DocumentView* result;
	TeplView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = tepl_tab_get_view ((TeplTab*) self);
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_DOCUMENT_VIEW) ? ((DocumentView*) _tmp0_) : NULL;
	return result;
}


Document*
document_tab_get_document (DocumentTab* self)
{
	Document* result;
	TeplBuffer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = tepl_tab_get_buffer ((TeplTab*) self);
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_DOCUMENT) ? ((Document*) _tmp0_) : NULL;
	return result;
}


guint
document_tab_get_auto_save_interval (DocumentTab* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_auto_save_interval;
	result = _tmp0_;
	return result;
}


void
document_tab_set_auto_save_interval (DocumentTab* self,
                                     guint value)
{
	guint _tmp0_;
	gboolean _tmp1_;
	guint _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (value > ((guint) 0));
	_tmp0_ = self->priv->_auto_save_interval;
	if (_tmp0_ == value) {
		return;
	}
	self->priv->_auto_save_interval = value;
	_tmp1_ = self->priv->_auto_save;
	if (!_tmp1_) {
		return;
	}
	_tmp2_ = self->priv->auto_save_timeout;
	if (_tmp2_ > ((guint) 0)) {
		Document* _tmp3_;
		Document* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		Document* _tmp7_;
		Document* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp3_ = document_tab_get_document (self);
		_tmp4_ = _tmp3_;
		_tmp5_ = document_get_location (_tmp4_);
		_tmp6_ = _tmp5_;
		g_return_if_fail (_tmp6_ != NULL);
		_tmp7_ = document_tab_get_document (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = document_get_readonly (_tmp8_);
		_tmp10_ = _tmp9_;
		g_return_if_fail (!_tmp10_);
		document_tab_remove_auto_save_timeout (self);
		document_tab_install_auto_save_timeout (self);
	}
	g_object_notify_by_pspec ((GObject *) self, document_tab_properties[DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY]);
}


gboolean
document_tab_get_auto_save (DocumentTab* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_auto_save;
	result = _tmp0_;
	return result;
}


void
document_tab_set_auto_save (DocumentTab* self,
                            gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_auto_save;
	if (value == _tmp0_) {
		return;
	}
	self->priv->_auto_save = value;
	_tmp4_ = self->priv->_auto_save;
	if (_tmp4_) {
		guint _tmp5_;
		_tmp5_ = self->priv->auto_save_timeout;
		_tmp3_ = _tmp5_ <= ((guint) 0);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		Document* _tmp6_;
		Document* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		_tmp6_ = document_tab_get_document (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = document_get_location (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp2_ = _tmp9_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		Document* _tmp10_;
		Document* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp10_ = document_tab_get_document (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = document_get_readonly (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp1_ = !_tmp13_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		document_tab_install_auto_save_timeout (self);
		return;
	}
	_tmp15_ = self->priv->_auto_save;
	if (!_tmp15_) {
		guint _tmp16_;
		_tmp16_ = self->priv->auto_save_timeout;
		_tmp14_ = _tmp16_ > ((guint) 0);
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		document_tab_remove_auto_save_timeout (self);
		return;
	}
	_tmp20_ = self->priv->_auto_save;
	if (!_tmp20_) {
		guint _tmp21_;
		_tmp21_ = self->priv->auto_save_timeout;
		_tmp19_ = _tmp21_ <= ((guint) 0);
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		_tmp18_ = TRUE;
	} else {
		Document* _tmp22_;
		Document* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		_tmp22_ = document_tab_get_document (self);
		_tmp23_ = _tmp22_;
		_tmp24_ = document_get_location (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp18_ = _tmp25_ == NULL;
	}
	if (_tmp18_) {
		_tmp17_ = TRUE;
	} else {
		Document* _tmp26_;
		Document* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
		_tmp26_ = document_tab_get_document (self);
		_tmp27_ = _tmp26_;
		_tmp28_ = document_get_readonly (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp17_ = _tmp29_;
	}
	g_return_if_fail (_tmp17_);
	g_object_notify_by_pspec ((GObject *) self, document_tab_properties[DOCUMENT_TAB_AUTO_SAVE_PROPERTY]);
}


static void
document_tab_class_init (DocumentTabClass * klass)
{
	document_tab_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DocumentTabPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_document_tab_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_document_tab_set_property;
	G_OBJECT_CLASS (klass)->finalize = document_tab_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_TAB_DOCUMENT_VIEW_PROPERTY, document_tab_properties[DOCUMENT_TAB_DOCUMENT_VIEW_PROPERTY] = g_param_spec_object ("document-view", "document-view", "document-view", TYPE_DOCUMENT_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_TAB_DOCUMENT_PROPERTY, document_tab_properties[DOCUMENT_TAB_DOCUMENT_PROPERTY] = g_param_spec_object ("document", "document", "document", TYPE_DOCUMENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY, document_tab_properties[DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY] = g_param_spec_uint ("auto-save-interval", "auto-save-interval", "auto-save-interval", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DOCUMENT_TAB_AUTO_SAVE_PROPERTY, document_tab_properties[DOCUMENT_TAB_AUTO_SAVE_PROPERTY] = g_param_spec_boolean ("auto-save", "auto-save", "auto-save", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
document_tab_instance_init (DocumentTab * self)
{
	self->priv = DOCUMENT_TAB_GET_PRIVATE (self);
	self->priv->ask_if_externally_modified = FALSE;
}


static void
document_tab_finalize (GObject * obj)
{
	DocumentTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DOCUMENT_TAB, DocumentTab);
	G_OBJECT_CLASS (document_tab_parent_class)->finalize (obj);
}


GType
document_tab_get_type (void)
{
	static volatile gsize document_tab_type_id__volatile = 0;
	if (g_once_init_enter (&document_tab_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DocumentTabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) document_tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DocumentTab), 0, (GInstanceInitFunc) document_tab_instance_init, NULL };
		GType document_tab_type_id;
		document_tab_type_id = g_type_register_static (tepl_tab_get_type (), "DocumentTab", &g_define_type_info, 0);
		g_once_init_leave (&document_tab_type_id__volatile, document_tab_type_id);
	}
	return document_tab_type_id__volatile;
}


static void
_vala_document_tab_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	DocumentTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT_TAB, DocumentTab);
	switch (property_id) {
		case DOCUMENT_TAB_DOCUMENT_VIEW_PROPERTY:
		g_value_set_object (value, document_tab_get_document_view (self));
		break;
		case DOCUMENT_TAB_DOCUMENT_PROPERTY:
		g_value_set_object (value, document_tab_get_document (self));
		break;
		case DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY:
		g_value_set_uint (value, document_tab_get_auto_save_interval (self));
		break;
		case DOCUMENT_TAB_AUTO_SAVE_PROPERTY:
		g_value_set_boolean (value, document_tab_get_auto_save (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_document_tab_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	DocumentTab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DOCUMENT_TAB, DocumentTab);
	switch (property_id) {
		case DOCUMENT_TAB_AUTO_SAVE_INTERVAL_PROPERTY:
		document_tab_set_auto_save_interval (self, g_value_get_uint (value));
		break;
		case DOCUMENT_TAB_AUTO_SAVE_PROPERTY:
		document_tab_set_auto_save (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



